(define-module (ordo interceptor errors)
  #:use-module (logging logger)
  #:use-module (srfi srfi-26)
  #:use-module (ordo interceptor)
  #:export (errors-interceptor))

(define (errors-interceptor)
  "Interceptor to log (and clear) the context error. This will allow any
   earlier #:leave handlers in the chain to run normally."
  (interceptor
   "handle-errors"
   #:error (lambda (ctx)
             (and=> (context-error ctx) (cut log-msg 'ERROR <>))
             (set-context-error! ctx #f))))
