(define-module (ordo interceptor tmp-dir)
  #:use-module (ice-9 format)
  #:use-module (ordo connection)
  #:use-module (ordo interceptor)
  #:export (tmp-dir-interceptor))

(define (tmp-dir-interceptor var-name)
  (define (create-tmp-dir ctx)
    (run (context-connection ctx) "mktemp" "--directory" #:check? #t #:return car))
  (define (cleanup-tmp-dir ctx)
    (and=> (var-ref ctx var-name #f)
           (lambda (dir-name)
             (run (context-connection ctx) "rm" "-rf" dir-name)))
    (var-delete! ctx var-name))
  (interceptor
   (format #f "manage-tmp-dir ~a" var-name)
   #:enter create-tmp-dir
   #:register var-name
   #:leave cleanup-tmp-dir
   #:error cleanup-tmp-dir))
